//--------------------------------------------------------------------//
// t@Cǂݍ

var TO_RADIAN=Math.PI/180;	// pxWAɕϊW

// ̌nf[^ft@Cǂݍ
// fileName - f[^t@C
function readServerFile(fileName){
  var xhr=new XMLHttpRequest();
  try{
    xhr.open('GET',fileName,false);
  }
  catch(e){
    alert(e);
  }
  xhr.onreadystatechange=function(){
    if((xhr.readyState===4) && ((xhr.status===0) ||
       (xhr.status===200))){
      try{
      	readModelData(xhr.responseText.split(/\r?\n/g));
      }
      catch(ex){
      	alert(ex);
      }
    }
  };
  xhr.send(null);
}

// [Jt@Cǂݍ
function readLocalFile() {
  var file=document.getElementById('localreadfile').files[0];
  if((file===null) || (file===undefined)){
    alert('t@Cw肳Ă܂');
    return;
  }
  var reader=new FileReader();
  reader.readAsText(file);
  reader.onload=function(e){
    try{
      readModelData(reader.result.split(/\r?\n/g));
    }
    catch(ex){
      alert(ex);
    }
  };
  hideModalWindow(FILE_WINDOW);
}

// [Jt@C
function writeLocalFile() {
  var file=document.getElementById('localwritefile').value.trim();
  if(file===''){
    alert('t@C󔒂ł');
    return;
  }
  var bd=parseInt(document.getElementById('selectbody').value);
  var te=parseFloat(document.getElementById('endtime').value);
  var s=timeHistory(model.bodies[bd],te).join('\n')+'\n';
  var blob=new Blob([s],{type:'text/plain'});
  if(window.navigator.msSaveBlob){		// IEp
    window.navigator.msSaveBlob(blob,file);
  }
  else{						// ̑̃uEU
    var a=document.createElement('a');
    a.href=URL.createObjectURL(blob);
    a.target='_blank';
    a.download=file;
    a.click();
  }
  hideModalWindow(FILE_WINDOW);
}

// ̌nf[^fǂݍ
// s - f[^̃Xg
function readModelData(s){
  removeObjects();
  model.clear();
  var alpha=0;
  var beta=0;
  var row=0;
  while(row<s.length){
    var ss=s[row].trim().replace(/\t/g,' ').split(/\s+/);
    if(ss.length>0){
      var keyWord=ss[0].toLowerCase();
      if((keyWord=='dt') && (ss.length>1)){
      	dt=parseFloat(ss[1]);
      }
      else if((keyWord=='baumgarte') && (ss.length>2)){
      	alpha=parseFloat(ss[1]);
      	beta=parseFloat(ss[2]);
      }
      else if((keyWord=='box') && (ss.length>5)){
      	var box=new Box(parseInt(ss[1]),parseFloat(ss[2]),
      	      	      	parseFloat(ss[3]),parseFloat(ss[4]),
      	      	      	parseFloat(ss[5]));
      	row++;
      	ss=s[row].trim().replace(/\t/g,' ').split(/\s+/);
      	setPosition(box.p,ss);
      	model.bodies.push(box);
      }
      else if((keyWord=='cylinder') && (ss.length>5)){
      	var cyl=new Cylinder(parseInt(ss[1]),parseFloat(ss[2]),
      	      	      	     parseFloat(ss[3]),parseFloat(ss[4]),
      	      	      	     parseFloat(ss[5]));
      	row++;
      	ss=s[row].trim().replace(/\t/g,' ').split(/\s+/);
      	setPosition(cyl.p,ss);
      	model.bodies.push(cyl);
      }
      else if((keyWord=='sphere') && (ss.length>4)){
      	var sph=new Sphere(parseInt(ss[1]),parseFloat(ss[2]),
      	      	      	   parseFloat(ss[3]),parseFloat(ss[4]));
      	row++;
      	ss=s[row].trim().replace(/\t/g,' ').split(/\s+/);
      	setPosition(sph.p,ss);
      	model.bodies.push(sph);
      }
      else if((keyWord=='balljoint') && (ss.length>8)){
      	var bj=new BallJoint(parseInt(ss[1]),parseInt(ss[2]),
      	      	      	     new THREE.Vector3(parseFloat(ss[3]),
      	      	      	      	      	       parseFloat(ss[4]),
      	      	      	      	      	       parseFloat(ss[5])),
      	      	      	     new THREE.Vector3(parseFloat(ss[6]),
      	      	      	      	      	       parseFloat(ss[7]),
      	      	      	      	      	       parseFloat(ss[8])));
      	model.rigids.push(bj);
      }
      else if((keyWord=='universaljoint') && (ss.length>8)){
      	var uj=new UniversalJoint(parseInt(ss[1]),parseInt(ss[2]),
      	      	      	      	  new THREE.Vector3(parseFloat(ss[3]),
      	      	      	      	      	      	    parseFloat(ss[4]),
      	      	      	      	      	      	    parseFloat(ss[5])),
      	      	      	      	  new THREE.Vector3(parseFloat(ss[6]),
      	      	      	      	      	      	    parseFloat(ss[7]),
      	      	      	      	      	      	    parseFloat(ss[8])));
      	model.rigids.push(uj);
      }
      else if((keyWord=='rotatejoint') && (ss.length>8)){
      	var rj=new RotateJoint(parseInt(ss[1]),parseInt(ss[2]),
      	      	      	       new THREE.Vector3(parseFloat(ss[3]),
      	      	      	      	      	      	 parseFloat(ss[4]),
      	      	      	      	      	      	 parseFloat(ss[5])),
      	      	      	       new THREE.Vector3(parseFloat(ss[6]),
      	      	      	      	      	      	 parseFloat(ss[7]),
      	      	      	      	      	      	 parseFloat(ss[8])));
      	model.rigids.push(rj);
      }
      else if((keyWord=='cylinderjoint') && (ss.length>9)){
      	var cj=new CylinderJoint(parseInt(ss[1]),parseInt(ss[2]),
      	      	      	      	 new THREE.Vector3(parseFloat(ss[3]),
      	      	      	      	      	      	   parseFloat(ss[4]),
      	      	      	      	      	      	   parseFloat(ss[5])),
      	      	      	      	 new THREE.Vector3(parseFloat(ss[6]),
      	      	      	      	      	      	   parseFloat(ss[7]),
      	      	      	      	      	      	   parseFloat(ss[8])),
      	      	      	      	 parseFloat(ss[9]));
      	model.rigids.push(cj);
      }
      else if((keyWord=='slider') && (ss.length>9)){
      	var sl=new Slider(parseInt(ss[1]),parseInt(ss[2]),
      	      	      	  new THREE.Vector3(parseFloat(ss[3]),
      	      	      	      	      	    parseFloat(ss[4]),
      	      	      	      	      	    parseFloat(ss[5])),
      	      	      	  new THREE.Vector3(parseFloat(ss[6]),
      	      	      	      	      	    parseFloat(ss[7]),
      	      	      	      	      	    parseFloat(ss[8])),
      	      	      	  parseFloat(ss[9]));
      	model.rigids.push(sl);
      }
      else if((keyWord=='spring') && (ss.length>10)){
      	var sp=new Spring(parseInt(ss[1]),parseInt(ss[2]),
      	      	      	  new THREE.Vector3(parseFloat(ss[5]),
      	      	      	      	      	    parseFloat(ss[6]),
      	      	      	      	      	    parseFloat(ss[7])),
      	      	      	  new THREE.Vector3(parseFloat(ss[8]),
      	      	      	      	      	    parseFloat(ss[9]),
      	      	      	      	      	    parseFloat(ss[10])),
      	      	      	  parseFloat(ss[3]),parseFloat(ss[4]));
      	model.springs.push(sp);
      }
      else if((keyWord=='gravity') && (ss.length>3)){
      	model.g.set(parseFloat(ss[1]),parseFloat(ss[2]),
      	      	    parseFloat(ss[3]));
      }
    }
    row++;
  }
  if((alpha>0) && (beta>0)) model.setBaumgarte(alpha,beta);
  model.init();
  initObject();
}

// ʒuiWϊjݒ肷
// p - ʒu
// ss - f[^
function setPosition(p,ss){
  setPosition2(p,ss[0].toLowerCase(),TO_RADIAN*parseFloat(ss[1]),
      	       TO_RADIAN*parseFloat(ss[2]),TO_RADIAN*parseFloat(ss[3]),
      	       TO_RADIAN*parseFloat(ss[4]),TO_RADIAN*parseFloat(ss[5]),
      	       TO_RADIAN*parseFloat(ss[6]));
}

// ʒuiWϊjݒ肷
// p - ʒu
// type - px̎
// th1,th2,th3 - ̉]p
// dth1,dth2,dth3 - ]p̎Ԕ
function setPosition2(p,type,th1,th2,th3,dth1,dth2,dth3){
  var c2=Math.cos(th2);
  var c3=Math.cos(th3);
  var s2=Math.sin(th2);
  var s3=Math.sin(th3);
  if(type=='euler'){
    var c1=Math.cos(th1);
    var s1=Math.sin(th1);
    setPositionFromRotate(p,c1*c3-s1*c2*s3,s1*c3+c1*c2*s3,s2*s3,
      	      	      	  -c1*s3-s1*c2*c3,-s1*s3+c1*c2*c3,s2*c3,
      	      	      	  s1*s2,-c1*s2,c2);
    p.w.set(s2*s3*dth1+c3*dth2,s2*c3*dth1-s3*dth2,c2*dth1+dth3);
  }
  else if(type=='taitbryan'){
    p.p.setFromEuler(new THREE.Euler(th1,th2,th3,'ZYX'));
    p.w.set(-s2*dth1+dth3,c2*s3*dth1+c3*dth2,c2*c3*dth1-s3*dth2);
  }
  else if(type=='bryant'){
    p.p.setFromEuler(new THREE.Euler(th1,th2,th3));
    p.w.set(c2*c3*dth1+s3*dth2,-c2*s3*dth1+c3*dth2,s2*dth1+dth3);
  }
}

// ]s񂩂ʒuݒ肷
// p - ʒu
// r11,r12,r13,r21,r22,r23,r31,r32,r33 - ]s̐
function setPositionFromRotate(p,r11,r12,r13,r21,r22,r23,r31,r32,r33){
  var trr=r11+r22+r33;
  var x,y,z,w=0.5*Math.sqrt(trr+1);
  if(w>0){
    x=0.25*(r23-r32)/w;
    y=0.25*(r31-r13)/w;
    z=0.25*(r12-r21)/w;
  }
  else{
    x=0.5*Math.sqrt(2+2*r11);
    if(x>0){
      y=0.5*r12/x;
      z=0.5*r13/x;
    }
    else{
      y=0.5*Math.sqrt(2+2*r22);
      if(y>0){
      	z=0.5*r23/y;
      }
      else{
      	z=1;
      }
    }
  }
  p.p.set(x,y,z,w);
}

// IvVvf쐬
// text - IvṼeLXg
// value - IvV̒l
function createOption(text,value){
  var opt=document.createElement('option');
  opt.value=value;
  opt.text=text;
  return opt;
}

// R{{bNX̃IvV폜
// sel - R{{bNX
function removeOptions(sel){
  if(sel.hasChildNodes()){
    while(sel.childNodes.length>0){
      sel.removeChild(sel.firstChild);
    }
  }
}

// t@CEBhE\
function showFileWindow(){
  calcStop();
  var bodies=document.getElementById('selectbody');
  removeOptions(bodies);
  for(var i=0;i<model.bodies.length;i++){
    bodies.appendChild(createOption(model.bodies[i].getName(),i));
  }
  showModalWindow(FILE_WINDOW);
}

// t@C
function cancelFile(){
  hideModalWindow(FILE_WINDOW);
// t@CI
  var localfile=document.getElementById('localreadfile');
  localfile.parentNode.innerHTML=localfile.parentNode.innerHTML;
}
