//--------------------------------------------------------------------//
// ʒu
var Position=function(){
  this.x=new THREE.Vector3();
  this.v=new THREE.Vector3();
  this.a=new THREE.Vector3();
  this.p=new THREE.Quaternion();
  this.w=new THREE.Vector3();
  this.dw=new THREE.Vector3();
};

// ʒuxNgԂ
// r - ̍Ẅʒu
Position.prototype.vector=function(r){
  return this.x.clone().add(r.clone().applyQuaternion(this.p));
};

// xxNgԂ
// r - ̍Ẅʒu
Position.prototype.velVector=function(r){
  var vl2=mulmv2(tilde(r),this.w).applyQuaternion(this.p);
  return this.v.clone().sub(vl2);
};

// dSʒuExݒ肷
// rl - w_̍̕Wʒu
// xg - w_̑S̍Wʒu
// vg - w_̑x
Position.prototype.setGcPosition=function(rl,xg,vg){
  this.x.subVectors(xg,rl.clone().applyQuaternion(this.p));
  var vv2=mulmv2(tilde(rl),this.w).applyQuaternion(this.p);
  this.v.addVectors(vg,vv2);
};

// ̍WʒuS̍Wɕϊ
// pt - Wʒu
Position.prototype.transPoint=function(pt){
  pt.applyQuaternion(this.p).subVectors(this.x,pt);
};

// IC[p[^̕ωʂ̂Q{ LւԂ
Position.prototype.eulerVel=function(){
  var ll=matrixL(this.p),l0=ll[0],l1=ll[1],l2=ll[2];
  var wx=this.w.x,wy=this.w.y,wz=this.w.z;
  return [l0[0]*wx+l1[0]*wy+l2[0]*wz,l0[1]*wx+l1[1]*wy+l2[1]*wz,
      	  l0[2]*wx+l1[2]*wy+l2[2]*wz,l0[3]*wx+l1[3]*wy+l2[3]*wz];
};

// xݒ肷
// av - xxNg
// i0 - f[^̊JnCfbNX
Position.prototype.setAcc=function(av,i0){
  this.a.fromArray(av,i0);
  this.dw.fromArray(av,i0+3);
};

// f[^XV
// dx - dSʒu̕ω
// dv - x̕ω
// dp - IC[p[^̕ω
// dw - px̕ω
Position.prototype.update1=function(dx,dv,dp,dw){
  this.x.add(dx);
  this.v.add(dv);
  this.p.set(this.p.x+dp[1],this.p.y+dp[2],this.p.z+dp[3],
      	     this.p.w+dp[0]);
  this.p.normalize();
  this.w.add(dw);
};

// f[^XV
// c - W
// dx - dSʒu̕ω
// dv - x̕ω
// dp - IC[p[^̕ω
// dw - px̕ω
Position.prototype.update2=function(c,dx,dv,dp,dw){
  this.x.addScaledVector(dx,c);
  this.v.addScaledVector(dv,c);
  var ch=0.5*c;
  this.p.set(this.p.x+ch*dp[1],this.p.y+ch*dp[2],this.p.z+ch*dp[3],
      	     this.p.w+ch*dp[0]);
  this.p.normalize();
  this.w.addScaledVector(dw,c);
};

// ʒũRs[Ԃ
Position.prototype.clone=function(){
  var pos=new this.constructor();
  pos.x=this.x.clone();
  pos.v=this.v.clone();
  pos.a=this.a.clone();
  pos.p=this.p.clone();
  pos.w=this.w.clone();
  pos.dw=this.dw.clone();
  return pos;
};

// ʒuRs[
// p - QƂʒu
Position.prototype.copy=function(p){
  this.x.copy(p.x);
  this.v.copy(p.v);
  this.a.copy(p.a);
  this.p.copy(p.p);
  this.w.copy(p.w);
  this.dw.copy(p.dw);
};

// ʒu\Ԃ
Position.prototype.toString=function(){
  return this.x.x+'\t'+this.x.y+'\t'+this.x.z+'\t'+this.p.w+'\t'+
      	 this.p.x+'\t'+this.p.y+'\t'+this.p.z;
};
